import { IOrder } from './entities';
export default class Zomato {
    private PHPSESSID;
    private CSRF;
    private homePage;
    private email;
    private orders;
    userFirstName: string | undefined;
    userLastName: string | undefined;
    userId: number | undefined;
    /**
     * Create browser instance and fetch cookies
     */
    init(): Promise<void>;
    /**
     * Request OTP on registered email address
     * @param email Registered email address
     */
    getOTP(email: string): Promise<void>;
    /**
     * Make verification request with OTP
     * @param otp Received OTP
     */
    verifyOTP(otp: string): Promise<void>;
    /**
     * Fetch and organize orders
     */
    fetchOrders(): Promise<void>;
    /**
     * Convert html orders to structured JSON array
     * @param html Orders data
     */
    extractOrders(html: string): IOrder[];
    /**
     * Print all visualizations
     */
    visualizeOrderStats(): void;
    /**
     * Print bar graph with monthly order count
     * @param orders All delivered orders
     */
    printMonthlyStats(orders: IOrder[]): void;
    /**
     * Print bar graph with weekday order count
     * @param orders All delivered orders
     */
    printWeekdayStats(orders: IOrder[]): void;
    /**
     * Print bar graph with restaurant order count
     * @param orders All delivered orders
     */
    printRestaurantStats(orders: IOrder[]): void;
}
