"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = __importDefault(require("node-fetch"));
var util_1 = require("./util");
var cheerio_1 = __importDefault(require("cheerio"));
var md5_1 = __importDefault(require("md5"));
var chalk_1 = __importDefault(require("chalk"));
var Zomato = /** @class */ (function () {
    function Zomato() {
        this.homePage = 'https://www.zomato.com';
        this.orders = [];
    }
    /**
     * Create browser instance and fetch cookies
     */
    Zomato.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, cookieString, cookies;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, node_fetch_1.default(this.homePage, {
                            method: 'GET',
                            headers: {
                                'Host': 'www.zomato.com',
                                'Origin': 'www.zomato.com',
                                'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36'
                            }
                        })];
                    case 1:
                        res = _a.sent();
                        cookieString = res.headers.get('set-cookie');
                        if (cookieString === null)
                            throw new Error('Set cookie header not present in request');
                        cookies = util_1.parseCookies(cookieString);
                        // Store important cookies
                        this.PHPSESSID = cookies.PHPSESSID.value;
                        this.CSRF = cookies.csrf.value;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Request OTP on registered email address
     * @param email Registered email address
     */
    Zomato.prototype.getOTP = function (email) {
        return __awaiter(this, void 0, void 0, function () {
            var res, resJSON;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Store email
                        this.email = email;
                        return [4 /*yield*/, node_fetch_1.default('https://www.zomato.com/php/get_login_otp.php', {
                                method: 'POST',
                                headers: {
                                    'Content-Type': 'application/x-www-form-urlencoded',
                                    'Cookie': 'PHPSESSID=' + this.PHPSESSID,
                                    'Host': 'www.zomato.com',
                                    'Origin': 'www.zomato.com',
                                    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36'
                                },
                                body: "login_id=" + email + "&csrf_token=" + this.CSRF
                            })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJSON = _a.sent();
                        // Check for errors
                        if (resJSON.status !== 'success')
                            throw new Error(resJSON.message);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Make verification request with OTP
     * @param otp Received OTP
     */
    Zomato.prototype.verifyOTP = function (otp) {
        return __awaiter(this, void 0, void 0, function () {
            var res, resJSON, cookieString, cookies;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, node_fetch_1.default('https://www.zomato.com/php/asyncLogin.php', {
                            method: 'POST',
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded',
                                'Cookie': 'PHPSESSID=' + this.PHPSESSID,
                                'Host': 'www.zomato.com',
                                'Origin': 'www.zomato.com',
                                'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36'
                            },
                            body: "login=" + this.email + "&otp=" + otp + "&csrf_token=" + this.CSRF
                        })];
                    case 1:
                        res = _b.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJSON = _b.sent();
                        // Check for errors
                        if (resJSON.status !== 'true')
                            throw new Error(resJSON.message);
                        cookieString = res.headers.get('set-cookie');
                        if (cookieString === null)
                            throw new Error('Set cookie header not present in request');
                        cookies = util_1.parseCookies(cookieString);
                        // Store important cookies
                        this.PHPSESSID = cookies.PHPSESSID.value;
                        this.CSRF = cookies.csrf.value;
                        // Store user info
                        _a = resJSON.name.split(' '), this.userFirstName = _a[0], this.userLastName = _a[1];
                        this.userId = resJSON.user_id;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Fetch and organize orders
     */
    Zomato.prototype.fetchOrders = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, resJSON, orders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, node_fetch_1.default(this.homePage + "/php/filter_user_tab_content.php", {
                            method: 'POST',
                            redirect: 'follow',
                            headers: {
                                'Host': 'www.zomato.com',
                                'Origin': 'www.zomato.com',
                                'Content-Type': 'application/x-www-form-urlencoded',
                                'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36',
                                'Cookie': 'PHPSESSID=' + this.PHPSESSID,
                            },
                            body: "user_id=" + this.userId + "&tab=ordering&order_history_offset=0&order_history_limit=10000"
                        })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJSON = _a.sent();
                        // Check for errors
                        if (resJSON.status !== 'success')
                            throw new Error(resJSON.message);
                        orders = this.extractOrders(resJSON.html);
                        // Store
                        this.orders = orders;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Convert html orders to structured JSON array
     * @param html Orders data
     */
    Zomato.prototype.extractOrders = function (html) {
        var orders = [];
        // Initialize html parser
        var $ = cheerio_1.default.load(html);
        var ordersElement = $('.order-history-snippet');
        // Extract info for each order
        ordersElement.each(function (i, element) {
            var status = $(element).children().find('.checkmark').next().text().trim();
            var restaurant = $(element).children().find('.header').children().text().trim();
            var city = $(element).children().find('.header').next().text().trim();
            var orderNumber = $(element).children().find('.order-number').text().trim().split(':')[1].trim();
            var cost = $(element).children().find('.cost').text().trim().slice(1);
            var date = $(element).children().find('.rating').next().text().trim();
            // Structure and append extracted info into JSON array
            orders.push({
                status: status,
                restaurant: restaurant,
                restaurantId: md5_1.default(restaurant),
                city: city,
                orderNumber: parseFloat(orderNumber),
                cost: parseFloat(cost),
                date: new Date(date)
            });
        });
        return orders;
    };
    /**
     * Print all visualizations
     */
    Zomato.prototype.visualizeOrderStats = function () {
        var orders = this.orders;
        // Filter delivered orders
        var deliveredOrders = orders.filter(function (o) { return o.status === 'Delivered'; });
        console.log();
        // Print total orders
        console.log('Your total delivered orders are: ' + chalk_1.default.cyanBright(deliveredOrders.length));
        console.log();
        // Print total amount spent
        console.log('You have spent a total sum of: ' + chalk_1.default.cyanBright('₹' + deliveredOrders.reduce(function (acc, item) { return acc += item.cost; }, 0).toFixed(2)));
        console.log();
        // Print monthly stats
        console.log('Your spend and orders count distributed monthly in the last 10 months:');
        this.printMonthlyStats(deliveredOrders);
        console.log();
        // Print weekday stats
        console.log('Weekday wise distribution of your orders:');
        this.printWeekdayStats(deliveredOrders);
        console.log();
    };
    /**
     * Print bar graph with monthly order count
     * @param orders All delivered orders
     */
    Zomato.prototype.printMonthlyStats = function (orders) {
        // Calculate monthly stats
        var monthlyStat = {};
        orders.map(function (order) {
            // Get month in words
            var orderDate = order.date;
            var orderMonth = orderDate.getMonth();
            var orderMonthInWords = util_1.monthNames[orderMonth];
            // Get last 2 digits if year
            var year = orderDate.getFullYear() % 2000;
            // Generate key
            var key = orderMonthInWords + "-" + year;
            // Generate object
            if (!monthlyStat[key]) {
                // When key is not present in object, initialize
                monthlyStat[key] = {
                    count: 1,
                    total: order.cost
                };
            }
            else {
                // When key is present in the object, increment
                monthlyStat[key].count += 1;
                monthlyStat[key].total += order.cost;
            }
        });
        // Print bars
        util_1.printBars(monthlyStat);
    };
    /**
     * Print bar graph with weekday order count
     * @param orders All delivered orders
     */
    Zomato.prototype.printWeekdayStats = function (orders) {
        // Calculate weekday stats
        var weekdayStat = {
            'Sunday': null,
            'Monday': null,
            'Tuesday': null,
            'Wednesday': null,
            'Thursday': null,
            'Friday': null,
            'Saturday': null
        };
        orders.map(function (order) {
            // Get month in words
            var orderDate = order.date;
            var orderDay = orderDate.getDay();
            var orderDayInWords = util_1.weekdayNames[orderDay];
            // Generate key
            var key = orderDayInWords;
            // Generate object
            if (!weekdayStat[key]) {
                // When key is not present in object, initialize
                weekdayStat[key] = {
                    count: 1,
                    total: order.cost
                };
            }
            else {
                // When key is present in the object, increment
                weekdayStat[key].count += 1;
                weekdayStat[key].total += order.cost;
            }
        });
        // Print bars
        util_1.printBars(weekdayStat, false);
    };
    /**
     * Print bar graph with restaurant order count
     * @param orders All delivered orders
     */
    Zomato.prototype.printRestaurantStats = function (orders) {
        // Calculate restaurant stats
        var restaurantStat = {};
        orders.map(function (order) {
            // Generate key
            var key = order.restaurant;
            // Generate object
            if (!restaurantStat[key]) {
                // When key is not present in object, initialize
                restaurantStat[key] = {
                    count: 1,
                    total: order.cost
                };
            }
            else {
                // When key is present in the object, increment
                restaurantStat[key].count += 1;
                restaurantStat[key].total += order.cost;
            }
        });
        // Print bars
        util_1.printBars(restaurantStat, false, true);
    };
    return Zomato;
}());
exports.default = Zomato;
