import { ICookieMap, IBarPrinterParam } from "./entities";
/**
 * Convert header set cookie string into an object
 * @param cookieString Set cookie header string
 */
export declare const parseCookies: (cookieString: string) => ICookieMap;
/**
 * Read input from user
 * @param question Question asked to the user for input
 */
export declare const readUserInput: (question: string, isSensitive?: Boolean) => Promise<string>;
export declare const monthNames: string[];
export declare const weekdayNames: string[];
/**
 * Print bars on console
 * @param data Values for printing
 * @param limit Max number of elements to print
 * @param width Max with of bar in the terminal
 */
export declare const printBars: (data: IBarPrinterParam, displayCost?: Boolean, performSort?: Boolean, limit?: number, width?: number) => void;
