"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inquirer_1 = __importDefault(require("inquirer"));
var chalk_1 = __importDefault(require("chalk"));
/**
 * Convert header set cookie string into an object
 * @param cookieString Set cookie header string
 */
exports.parseCookies = function (cookieString) {
    // Split string
    var cookieArray = cookieString.split(',');
    // Sub strings
    var cookieSubArray = cookieArray.map(function (cookie) { return cookie.split(';').map(function (c) { return c.trim(); }); });
    // Join date strings back to the parent cookie array
    var mergedCookieArray = [];
    for (var i = 0; i < cookieSubArray.length; i++) {
        if (i + 1 < cookieSubArray.length && cookieSubArray[i + 1][0].search(/[0-9]/) === 0) {
            cookieSubArray[i][cookieSubArray[i].length - 1] += ', ' + cookieSubArray[i + 1][0];
            cookieSubArray[i + 1].splice(0, 1);
            mergedCookieArray.push(cookieSubArray[i].concat(cookieSubArray[i + 1]));
            i += 1;
        }
        else {
            mergedCookieArray.push(cookieSubArray[i]);
        }
    }
    // Convert to object
    var cookieObject = {};
    mergedCookieArray.map(function (mergedCookie) {
        var keyValueArray = mergedCookie.map(function (cookie) { return cookie.split('='); });
        var singleCookieObject = {};
        keyValueArray.map(function (c) {
            if (c[0] == keyValueArray[0][0]) {
                singleCookieObject['name'] = keyValueArray[0][0];
                singleCookieObject['value'] = c[1];
            }
            else
                singleCookieObject[c[0]] = c[1] ? c[1] : true;
        });
        cookieObject[keyValueArray[0][0]] = singleCookieObject;
    });
    return cookieObject;
};
/**
 * Read input from user
 * @param question Question asked to the user for input
 */
exports.readUserInput = function (question, isSensitive) {
    if (isSensitive === void 0) { isSensitive = false; }
    return __awaiter(void 0, void 0, void 0, function () {
        var answers;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, inquirer_1.default.prompt([
                        {
                            name: 'key',
                            message: question,
                            type: isSensitive ? 'password' : 'input'
                        },
                    ])];
                case 1:
                    answers = _a.sent();
                    if (!answers.key)
                        // When email address is invalid
                        throw new Error('Invalid input.');
                    else
                        // When email address ia valid
                        return [2 /*return*/, answers.key];
                    return [2 /*return*/];
            }
        });
    });
};
// Month index to words
exports.monthNames = [
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
];
// Weekday index to words
exports.weekdayNames = [
    "Sunday",
    "Monday",
    "Tuesday",
    "Wednesday",
    "Thursday",
    "Friday",
    "Saturday"
];
/**
 * Print bars on console
 * @param data Values for printing
 * @param limit Max number of elements to print
 * @param width Max with of bar in the terminal
 */
exports.printBars = function (data, displayCost, performSort, limit, width) {
    if (displayCost === void 0) { displayCost = true; }
    if (performSort === void 0) { performSort = false; }
    if (limit === void 0) { limit = 10; }
    if (width === void 0) { width = 50; }
    console.log('here');
    var block = '\u2580';
    // Convert object to 
    var labelValueArr = Object.keys(data).map(function (key) {
        return data[key] ? {
            label: key,
            value: data[key].total ? data[key].total : 0,
            count: data[key].count
        } : {
            label: key,
            value: 0,
            count: 0
        };
    });
    // Calculate max value for normalization
    var maxValue = Math.max.apply(Math, labelValueArr.map(function (x) { return x.count; }));
    labelValueArr
        // Select max elements to display
        .slice(0, limit)
        // Reverse sort
        .sort(function (a, b) { return performSort ? b.count - a.count : 0; })
        // Print bars
        .forEach(function (_a) {
        var label = _a.label, value = _a.value, count = _a.count;
        // Remove decimals
        var truncatedValue = Math.trunc(count);
        console.log(
        // Display initial white space
        ' '.repeat(1), 
        // Display count
        chalk_1.default.whiteBright(truncatedValue), 
        // Display white space depending on number of digits in count
        ' '.repeat(4 - String(truncatedValue).length), 
        // Display bars with normalized values
        block.repeat(width * truncatedValue / maxValue), 
        // Display key
        chalk_1.default.yellow(label), 
        // Display cost
        chalk_1.default.red(displayCost ? '₹' + value.toFixed(0) : ''));
    });
};
